/*
 * Copyright 2010 by Kappich Systemberatung Aachen
 * 
 * This file is part of de.bsvrz.pua.prot.
 * 
 * de.bsvrz.pua.prot is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * de.bsvrz.pua.prot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with de.bsvrz.pua.prot.  If not, see <http://www.gnu.org/licenses/>.
 */

package de.bsvrz.pua.prot.data;

import de.bsvrz.dav.daf.main.Data;

/**
 * @author Kappich Systemberatung
 * @version $Revision: 0000 $
 */
class ProtocolDataTextValue implements Data.TextValue {

	/**
	 * Datum
	 */
	protected final AttributeProtocolData _data;

	/**
	 * Text-Ansicht auf ein Datum (Die anderen Ansichten erben von dieser Klasse)
	 * @param attributeProtocolData Datum
	 */
	public ProtocolDataTextValue(final AttributeProtocolData attributeProtocolData) {
		_data = attributeProtocolData;
	}

	public String getText() {
		final String suffixText = getSuffixText();
		if(suffixText.length() == 0) return getValueText();
		return getValueText() + " " + suffixText;
	}

	public String getValueText() {
		return _data.getInternalValue().toString();
	}

	public String getSuffixText() {
		return "";
	}

	public void setText(final String text) {
		throw new UnsupportedOperationException(ProtocolData.MESSAGE_NO_CHANGE);
	}
}
