Versionsverlauf
===============

## [Noch nicht veröffentlicht]


## [Version 2.10.1]

- NERZ: Umstellung auf Gradle, Build durch FTB und Bereitstellung auf NERZ-Repositories

## Version 2.10.0

- **Änderungen**

  Folgende Erweiterungen und Änderungen gegenüber vorhergehenden Versionen wurden durchgeführt:

  - Die Kommunikation zwischen PuA-Server und PuA-Client wurde dahingehend erweitert, dass nun beim Verbindungsaufbau gegenseitig die Version des verwendeten Kommunikationsprotokolls (aktuell 4) ausgetauscht wird. Zukünftige Änderungen des Kommunikationsprotokolls werden damit vereinfacht.

  - Nerz-FM–173: Die Ersetzung von im Skript angegeben Typen durch die konkreten Objekte wurde überarbeitet. Der Typ den Hauptobjekts muss nun nicht mehr mit dem im Skript angegebenem Typ identisch sein, so kann man jetzt auch beispielsweise im Skript den Typ typ.messQuerschnittAllgemein verwenden, aber ein Hauptobjekt vom davon abgeleiteten Typ typ.messQuerschnitt angeben.

  - Nerz-ÄM–103: Es wurden folgende künstliche Beschränkungen bei der Verwendung von temporären Attributen entfernt:

    - Temp-Attribute müssen nicht mehr im Spalten-Bereich angegeben werden.

    - Temp-Attribute müssen nicht mehr zwingend auf reelle Attribute verweisen.

    Dadurch können temporäre Attribute nun auch zur Bestimmung von Zwischenergebnissen oder als Konstanten verwendet werden. Beispiel:

    ```
    spalten:
        tempAttribut messstelleQKfz
    definitionen:
        alias mq = typ.messQuerschnitt
        alias abfahrt1 = typ.messQuerschnitt
        tempAttribut mqQKfz: att.verkehrsStärkeStunde =
            mq:atg.verkehrsDatenKurzZeitMq:asp.analyse:QKfz.Wert
        tempAttribut abfahrt1QKfz: att.verkehrsStärkeStunde =
            abfahrt1:atg.verkehrsDatenKurzZeitMq:asp.analyse:QKfz.Wert
        tempAttribut korrekturFaktor: att.zahl = potenz(2, 0.5)
        tempAttribut messstelleQKfz: att.verkehrsStärkeStunde =
        (mqQKfz + abfahrt1QKfz) * korrekturFaktor
    ```

  - Nerz-FM–176:

    1. Abbruch des Skripts, wenn bei der Auswertung des Ausdrucks hinter einschränkung einen Fehler auftritt. Clientseitig wird eine entsprechende Fehlermeldung mit der Erläuterung des Problems zurückgegeben werden. Serverseitig wird dann eine Debug-Nachricht mit der Erläuterung des Problems und dem Skriptnamen ausgegeben werden.

    2. Der Ergebnistyp eines Ausdrucks kann mit neuen Funktionen in PuA-Skripten geprüft werden. Alle neuen Funktionen liefern (bei Anwendung mit genau einem Argument) einen Wahrheitswert zurück. Folgende Funktionen wurden implementiert:

       - istFehler() liefert true zurück, wenn das Argument zu einem Fehler ausgewertet wurde.
       - istZahl() liefert true zurück, wenn das Argument eine Zahl darstellt.
       - istZustand() liefert true zurück, wenn das Argument einen Zustand darstellt.
       - istLeer() liefert true zurück, wenn das Argument leer ist (wie z.B. bei einem leeren Datensatz).
       - istText() liefert true zurück, wenn das Argument eine Zeichenkette darstellt.
       - istWahrheitswert() liefert true zurück, wenn das Argument einen Wahrheitswert darstellt.

    3. Änderung der Semantik von und bzw. oder Verknüpfungen. Beide Verknüpfungen liefern nicht nur mehr dann einen Wahrheitswert zurück, wenn beide Operatoren Wahrheitswerte sind, sondern auch dann, wenn nur ein Operator bei der Auswertung einen Wahrheitswert liefert und bei der Auswertung des anderen ein Fehler aufgetreten ist.

       - Die oder Verknüpfung liefert genau dann wahr zurück, wenn mindestens einer der beiden Operanden wahr ist. Auch dann, wenn der andere Operand nicht ausgewertet werden konnte (Fehler).
       - Die und Verknüpfung liefert genau dann falsch zurück, wenn mindestens einer der beiden Operanden falsch ist. Auch dann, wenn der andere Operand nicht ausgewertet werden konnte (Fehler).
       - Wenn beide Operatoren nicht ausgewertet können, dann liefern sowohl und als auch oder einen entsprechenden Fehler zurück.

    4. Änderung der Semantik von Vergleichsoperatoren, wenn einer der Operatoren ein Zustand und der andere eine Zahl ist. Wenn ein Zustandswert mit einem Zahlenwert verglichen wird, dann wird bei den Operatoren kleiner, kleinergleich, größer, größer-gleich und gleich der Wahrheitswert falsch bzw. beim Operator ungleich der Wahrheitswert wahr zurückgeliefert.

## Version 2.9.0

- **Änderungen**

  Folgende Erweiterungen und Änderungen gegenüber vorhergehenden Versionen wurden durchgeführt:

  - Nerz-Ä–98: Die bisherige getIsActive()-Methode im PuA-Client wurde durch einen Listener-Mechanismus ersetzt, der den aktuellen Status von PuA und dem von PuA verwendeten Archivsystem ohne Wartezeit bestimmt. Hierzu gibt es die neuen Methoden isPuaOnline(), isArchiveOnline(), addStatusListener(listener) und removeStatusListener(listener). Vorraussetzung ist ein gleichzeitiges Update des PuA-Servers, da sonst dynamische Änderungen beim Zustand des Archivsystems nicht korrekt bestimmt werden können. Ob PuA läuft, kann unabhängig von der Version des Servers in jedem Fall mit isPuaOnline() bestimmt werden.

  - Nerz-Ä–98: Ebenso wie der Status-Listener können jetzt auch die ProtokollListener (addProtocolListener(listener)) clientseitig jederzeit registriert werden, unabhängig davon ob PuA aktuell läuft oder nicht. Der eigentliche Listener beim PuA-Server wird automatisch angemeldet sobald PuA verfügbar ist und automatisch abgemeldet, sobald PuA nicht mehr verfügbar ist.

  - Nerz-Ä–99: Die Methoden PuaClient.suspendProtocol() und PuaClient.resumeProtocol(), die zur manuellen Flusskontrolle gedacht waren, werden nicht mehr benötigt und wurden auf @deprecated gesetzt, weil mittlerweile eine automatische Flusskontrolle zwischen PuA-Server und PuA-Client implementiert ist.

  - Nerz-Ä–100: Die Klasse ProtocolResultData, die clientseitig eine Ergebniszeile abbildet, wurde überarbeitet und dokumentiert. Es gibt jetzt neue Methoden, um für jeden Spaltenindex die folgenden Attribute abzufragen:

    - Datenzeit
    - Archivzeit
    - Datenindex
    - Datenzustand (Keine Daten, Keine Quelle, Fehler, Leer, . . . )
    - Archivdatenzustand

    Temporäre Attribute erben den Datenzustand (soweit sinnvoll) von den Attributen, die in die Berechnung eingehen. Kann eine Berechnung beispielsweise nicht durchgeführt werden, weil ein Eingangswert “Keine Daten” hat, dann hat das Ergebnis ebenfalls den Zustand “Keine Daten”.

    Der Datenzustand kann nur abgefragt werden, wenn der PuA-Server aktualisiert wird (und ein neues Protokoll erstellt wird). Sonst wird immer der Zustand PuADataState.NOT_AVAILABLE zurück gegeben.

  - Nerz-Ä–100: Die Berechnungen, die der PuA-Server bei der Auswertung von Skripten durchführt, wurden überarbeitet, sodass nach Möglichkeit in Fehlersituationen eine sinnvolle Fehlermeldung und ein sinnvoller Datenzustand an den Client übertragen wird.

    Die Methode ResultValue.performOperationOn() wurde von PuA nicht verwendet und aufgrund der mangelhaften Fehlerbehandlung auf @Deprecated gesetzt. Als Ersatz sollte (beispielsweise bei der Implementierung von benutzerdefinierten Funktionen und Aggregationen) die Klasse de.bsvrz.pua.prot.util.ArithmeticOperation oder de.bsvrz.pua.prot.util.ArithmeticOperationEx verwendet werden.

  - Die Abfrage nach Skript-Standardwerten gibt die Aliase, Pseudoaspekte und Aspektbindungen nun in der Reihenfolge zurück, in der sie im Skript definiert wurden. Hierfür müssen sowohl Server als auch Client die neue PuA-Version und Kernsoftware ab 3.7.0 verwenden. Ansonsten ist die Reihenfolge wie bisher undefiniert.

  - Die PuA-Datenobjekte aus ProtocolResultData.getData() erhalten jetzt eine klarere toString()-Ausgabe bei Fehlerwerten. Die zurückgegebenen Objekte vom Typ ProtocolData besitzen jetzt die neue Methode isError() mit denen abgefragt werden kann, ob es sich bei diesem Wert um einen Fehlerwert handelt. Die Fehlermeldung selbst kann dann wie bisher mit asTextValue().getValueText() abgerufen werden.

  - Zur Vereinfachung von Berechnungen können Wahrheitswerte jetzt mit den Werten Wahr=1 und Falsch=0 (entsprechend att.jaNein) in Berechnungen eingehen. Hierdurch ändern sich die standardmäßigen Aggregationsfunktionen, sodass beispielsweise bei der Summe-Aggregation als Ergebnis die Anzahl der wahren Werte berechnet wird und bei der Durchschnittsaggregation der Anteil der wahren Werte. Diese Werte kann man entsprechend auch über das ProtocolData-Interface abfragen (z. B. als skalierten Zahlenwert).

  - Die Klasse PuaClient implementiert jetzt die Schnittstelle AutoCloseable und bietet daher die Methode close(), mit der sämtliche belegte Resourcen und Datenverteiler-Anmeldungen des PuA-Clients freigegeben werden können.

  - Die Klasse ProtocolResultStream implementiert jetzt die Schnittstelle AutoCloseable und bietet daher die Methode close(), mit der die Übertragung der Protokolldaten beendet wird, sofern der Client noch nicht alle Daten entgegengenommen hat. Die bisherige Methode abort() mit der gleichen Funktionalität wurde auf @Deprecated gesetzt, da der Name vermuten lässt, die gesamte Protokollerstellung würde abgebrochen werden, was nicht der Fall ist.

  - ProtocolResultStream.getJobId() liefert jetzt nur noch null zurück, wenn es keine gültige Auftrags-Id gibt, PuA also beispielsweise den Auftrag nicht angenommen hat. Es muss nicht mehr selbst auf die Übertragung der Auftrags-Id gewartet werden.

  - Mit dem neuen Aufrufargument -clientTimeout= kann ein Minutenwert angegeben werden, nach dem bei nicht reagierenden Clients ein Protokollabruf automatisch von PuA abgebrochen wird. Wenn das Argument nicht verwendet wird, dann wird als Default-Wert 15 (Minuten) verwendet. Mit dem Wert -1 kann der Timeout deaktiviert werden.

  - Nerz-F–160: Wenn in einem Protokoll mehrere Archivdatenarten („Online-Daten“, „nachgeforderte Online-Daten“, „nachgelieferte Daten“ und „nachgeforderte nachgelieferte Daten“) angefordert wurden, wurden diese Archivdatenarten von PuA einzeln nacheinander abgefragt, was dazu führte, dass diese im Protokoll nacheinander und nicht zeitlich sortiert ausgegeben wurden. Das Verhalten wurde so geändert, dass die Archivdatenarten gemeinsam abgefragt werden und das Archivsystem die Daten entsprechend nach Datenzeit sortiert.

- **Bugfixes**

  Folgende Probleme vorhergehender Versionen wurden behoben:

  - Nerz-F–157: Die Verwendung des Moduls SimpleSender in PuA wurde durch ein verbessertes Modul ersetzt, wodurch Benachrichtigungen (z. B. über fertiggestellte Protokolle) an Clients nun asynchron versendet werden und PuA bei negativer Sendesteuerung nicht mehr in Timeouts läuft. Clients, die sich beenden, ohne entsprechende Listener abzumelden, werden nun von PuA automatisch aus den internen Datenstrukturen entfernt und verursachen keine Blockierungen mehr.

  - Nerz-F–158: Bei dem Abruf eines nicht vorhandenen Protokolls wurde die Fehlermeldung des PuA-Servers unter der falschen ID verschickt, wodurch der Client diese nicht zurordnen konnte und in einen Timeout lief. Hier wurde sowohl der PuA-Server angepasst, sodass dieser die richtige ID zum Versand der Fehlermeldung benutzt, als auch der Client, der jetzt auch Fehlermeldungen unter der falschen ID (Anfrage-ID statt Auftrags-ID) empfängt.

  - Nerz-F–159: In der Klasse ArchiveUser wurden mehrere ThreadSynchronisierungsprobleme korrigiert, die zu einem Absturz des PuA-Servers führen konnten.

  - Nerz-F–160: Wenn mehr als ein Zeitintervall und mehrere Archivdatenarten angefragt wurden, lieferte PuA nur für das erste Zeitintervall alle Archivdatenarten.

  - Die Aggregation von Boolean-Werten in Attributlisten oder Arrays konnte fehlerhafte Werte zurückliefern.

  - Bei Protokollen mit Archivanfragen konnte es bei vielen abgefragten Daten unter bestimmten Umständen zu einer fehlerhaften Wiederholung von Datensätzen am Ende vom Protokoll kommen.

  - Beim clientseitigen Abbruch des ProtokollResultStreams wird nun explizit eine Nachricht an den PuA-Server zum Protokollabbruch gesendet, statt sich darauf zu verlassen, dass PuA die Protokollerstellung automatisch anhält.

## Version 2.8.4

- **Bugfixes**

  Folgende Probleme vorhergehender Versionen wurden behoben:

  - Beim Beenden von PuA konnte es wegen eines Thread-Synchronisierungsfehlers dazu kommen, dass einzelne Threads von PuA nicht beendet wurden und entsprechende Warnungen ausgegeben wurden.

## Version 2.8.3

- **Bugfixes**

  Folgende Probleme vorhergehender Versionen wurden behoben:

  - Beim Start von PuA konnte es wegen eines Thread-Synchronisierungsfehlers zu einer ConcurrentModificationException kommen.

## Version 2.8.2

- **Hinweis**

  Das bisher zusammen mit PuA ausgelieferte Distributionspaket *de.bsvrz.sys.funclib.losb* wird seit Version 3.6.3 mit der Kernsoftware ausgeliefert.

- **Bugfixes**

  Folgende Probleme vorhergehender Versionen wurden behoben:

  - PuA hat versucht, den Applikationsnamen in den ClientDavParameters nach dem Verbindungsaufbau mit dem Datenverteiler zu ändern. Dies hat mit neueren Kernsoftware-Version (>=3.6.3) zu Warnungen bzw. Fehlermeldungen geführt.

  - Der optionale Aufrufparameter “-konfigurationsVerantwortlicher=”, mit dem man das für Auswertungen zu verwendende Archivsystem angeben kann, wurde nicht an allen erforderlichen Stellen richtig ausgewertet

## Version 2.8.1

- **Voraussetzungen**

  - **Datenmodelle**

    Die Nutzung der erweiterten Funktionalität setzt eine Aktualisierung folgender Konfigurationsbereiche vorraus:

    - kv.bea:

      – kb.tmVewProtokolleGlobal in Version 5

    - kv.kappich:

      – kb.systemModellGlobal in Version 33

  - **Bibliotheken**

    Es wird eine aktualisierte Version des Distributionspakets *de.bsvrz.sys.funclib.losb* mit gleichem (oder neuerem) Releasedatum vorrausgesetzt.

- **Bugfixes**

  Folgende Probleme vorhergehender Versionen wurden behoben:

  - In seltenen Fällen konnte es passieren, dass die Flusskontrolle im PuA-Server den Datenversand zu lange gebremst hat. Der PuA-Server setzt den Versand von Datensätzen nun unmittelbar fort, sobald eine Flusskontroll-Nachricht eingetroffen ist.

## Version 2.8.0

- **Voraussetzungen**

  - **Datenmodelle**

    Die Nutzung der erweiterten Funktionalität setzt eine Aktualisierung folgender Konfigurationsbereiche vorraus:

    - kv.bea:

      – kb.tmVewProtokolleGlobal in Version 5

    - kv.kappich:

      – kb.systemModellGlobal in Version 33

  - **Bibliotheken**

    Es wird eine aktualisierte Version des Distributionspakets *de.bsvrz.sys.funclib.losb* mit gleichem (oder neuerem) Releasedatum vorrausgesetzt.

- **Neue Features**

  Folgende Erweiterungen gegenüber vorhergehenden Versionen wurden durchgeführt:

  - Nerz-Ä–13: PuA verwendet eine Warteschlange für Protokollaufträge, wenn keine freien Threads zur Bearbeitung mehr frei sind. Die Klasse PuaClient und analog der PuA-Server wurden um eine Methode erweitert den Inhalt dieser Warteschlange und die aktuell in Bearbeitung befindlichen Aufträge abzurufen. Hierfür wurde am PuaClient die Methode getJobList() hinzugefügt. Über die zurückgegebenen JobInProgress-Objekte können damit alle weiteren Informationen über die Aufträge abgefragt werden.

    - Jeder Protokollauftrag enthält nun zur Identifizierung eine eindeutige Auftrags-ID, die die Protokoll-ID clientseitig an mehreren Stellen ersetzt.

      - Bei Protokoll-Erstellen-Aufträgen ist die Auftrags-ID identisch zur Protokoll-ID des erstellten Protokolls.
      - Bei Aufträgen, die gespeicherte oder ungelesene Protokolle abrufen, ergibt sich eine neue eindeutige Auftrags-ID.
      - Die Auftrags-ID lässt sich jeweils über die neue Methode ProtocolResultStream.getJobId() abrufen.

    - Die Methode abortProtocol() wurde so erweitert, dass mit der Methode nun beliebige protokollbezogene Aufträge anhand ihrer Auftrags-ID (JobId) abgebrochen werden können. Zudem können nun auch Aufträge abgebrochen werden, die sich noch in der Warteschlange befinden.

    - Die Methode getStatus() arbeitet nun ebenfalls mit Auftrags-IDs und wurde so erweitert, dass nun auch der Status von Aufträgen in der Warteschlange abgerufen werden kann.

    - Die Methoden zur Flusskontrolle suspendProtocol()/resumeProtocol() arbeiten nun ebenfalls mit Auftrags-IDs und erlauben auch das Anhalten und Fortsetzen von anderen protokollbezogenen Aufträgen wie dem Abruf von Protokollen.

  - Nerz-Ä–14: Die bisherige Listener-Funktionalität im PuaClient wurde erweitert und erlaubt es nun auch, über das Gelöschtwerden und Gelesenwerden eines Protokolls informiert zu werden. Hierzu kann das bisherige Interface ProtocolListener durch das neue Interface ProtocolListenerEx ersetzt werden wodurch die zusätzlichen Methoden protocolRemoved() und protocolRead() bereitgestellt werden, die beliebig implementiert werden können. An den Funktionsaufrufen im PuaClient ändert sich nichts, die Methode addProtocolListener() wurde überladen und akzeptiert beide Interfaces. Die bisherige Methode protocolFinished() wurde im neuen Interface in jobFinished() umbenannt und enthält nun (sofern auch ein aktueller PuA-Server eingesetzt wird) umfangreiche Informationen über den fertiggestellten Auftrag, beispielsweise den Typ des Auftrags (Protokollerstellung, Protokollabruf, etc.), ob er erfolgreich abgeschlossen war und ob ein Protokoll als Resultat des Auftrags gespeichert wurde.

  - Nerz-Ä–14: Mit der Methode PuaClient.deleteSaveProtocol() können nun auch ungelesene Protokolle gelöscht werden.

  - Nerz-Ä–14: Der PuaClient verwendet in Verbindung mit einem aktuellen PuAServer nun eine automatische Flusskontrolle, die die Anzahl der serverseitig versendeten Protokolldaten bei Protokoll-Erstellen- und Protokoll-Abrufen-Aufträgen begrenzt. Dafür wurde ein “Sliding-Window”-Mechanismus implementiert, welcher automatisch verwendet wird. Um die Parameter der Flusskontrolle einzustellen oder die automatische Flusskontrolle optional zu deaktivieren gibt es die neuen Funktionen PuaClient.get/setFlowControlWindowSize().

  - Nerz-Ä–15: Bei Zustandsprotokollen besteht nun die Möglichkeit, anzugeben, ob “Keine Änderung”- bzw. NoChange-Markierungen je Zeile (wie bisher) oder je Zelle/Datensatz generiert werden sollen. Hierfür gibt es in der Klasse ProcessingParameter die neuen Methoden get/setNoChangeMarker, mit denen die Art der Markierung festgelegt werden kann.

    - Daraus folgend kann nun in PuA-Scripten nun auch eine der beiden Markierungsarten als Standard festgelegt werden. Hierzu gibt es im Standards-Block die neuen Definitionen unveraendertkennung pro zeile und unveraendertkennung pro zelle. (Statt unveraendertkennung ist auch die Variante mit ä möglich.)

    - Bei Verwendung der neuen zellenweisen Markierungen werden keine zeilenweisen ProtocolNoChanges-Datensätze mehr übertragen, stattdessen erhalten die einzelnen Datumswerte, bei denen sich keine Änderungen zum vorherigen Wert ergeben haben, im ExpressionResult die neue Kennung ResultType.NO_CHANGE. Beim Zugriff über ProtocolData-Objekte gibt die isDefined()- Methode bei solchen Datensätzen false zurück und die neue Methode ProtocolData.isNoChange() liefert true.

    - Einzelne Datensätze mit NoChange-Markierung werden standardmäßig durch ein einzelnes Hochkomma (’) dargestellt.

    - Damit erfolgreich die neue Markierungsart verwendet werden kann, muss sowohl der Client als auch der Server aktualisiert werden. Wird ein neuer Client und ein veralteter PuA-Server eingesetzt, wird der Server immer zeilenweise Markierungen erstellen. Ruft ein veralteter Client ein Protokoll mit datensatzweisen NoChange-Markierungen ab, erscheinen diese für den Client so, als wären dort keine Daten vorhanden.

  - Nerz-Ä–52: Es wurde die Möglichkeit hinzugefügt, Ereignisprotokolle zu erzeugen. Ereignisprotokolle bieten die Möglichkeit, Daten genau so abzurufen, wie sie im Archivsystem stehen, insbesondere werden Datensätze nicht aufgefüllt und identische Datensätze werden nicht durch NoChange-Markierungen ersetzt. Dazu wurden in der ProcessingParameter-Klasse neue Methoden get/setProtocolType() ergänzt, mit denen diese neue Protokollart festgelegt werden kann. Die bisherigen Methoden zur Festlegung der Protokollart get/setDeltaProtocol() werden daher nur noch aus Kompatibilitätsgründen unterstützt.

    - Daraus folgend kann nun in PuA-Scripten nun auch die Protokollart “Ereignisprotokoll” als Standard festgelegt werden. Zum Abruf des neuen Standardwertes wurde die Klasse AtlDefaults analog um die Methode getProtocolType() ergänzt. Die bisherige Methode getDeltaProtocol() sollte nicht mehr verwendet werden.

    - Damit erfolgreich Ereignisprotokolle erstellt werden können, muss sowohl der Client als auch der Server aktualisiert werden. Wird nur der Client aktualisiert, erstellt der Server stattdessen Zustandsprotokolle. Wird der Server aktualisiert kann ein alter Client gespeicherte Ereignisprotokolle lesen, die Methode getDeltaProtocol() liefert dann false. Zum Abruf des Default-Wertes “Ereignisprotokoll” muss außerdem das verwendete Datenmodell kb.tmVewProtokolleGlobal aktualisiert werden.

- **Bugfixes**

  Folgende Probleme vorhergehender Versionen wurden behoben:

  - ExpressionResult hatte einen statischen NumberFormat-Member. Da die JavaKlasse NumberFormat nicht threadsicher ist, konnte das zu seltenen, zufällig auftretenden, Problemen wie falschen Textausgaben und Exceptions führen.

  - Serialisierung der Klasse DataInformation angepasst, sodass private Attribute wie Protokollart nicht mehr überflüssigerweise an den Client übertragen werden, was die Performance verbessern sollte.

  - Synchronisierung in ThreadPool-Klasse korrigiert, Methode getWaitingProtocols() war nicht threadsicher und konnte z. B. eine ConcurrentModificationException erzeugen.

  - Klasse Processing hat auf Boolean.TRUE/Boolean.FALSE synchronisiert, was zu schwer diagnostizierbaren Problemen wie Deadlocks führen konnte.

  - Bei PuaClient.abortProtocol() wurde nicht in jedem Fall eine entsprechende (Fehler-)Meldung (“Der Versand von Protokolldatensätzen wurde abgebrochen”) an den Client übertragen, der gerade das Protokoll abruft. Diese Fehlermeldung
wurde ergänzt.

  - Die Erzeugung von Protokoll-IDs wurde angepasst und ist nun unabhängig von irgendwelchen Zeitstempeln, sodass eventuell auftretende Probleme durch Erzeugung von mehreren Protokollen zur exakt selben Zeit vermieden werden.

  - Beim PuaClient konnten Protokollantworten mit Benachrichtigungen zu fertiggestellten Protokollen durcheinandergebracht werden, was bei der Erweiterung der Benachrichtigungen gemäß Nerz-Ä–14 zu Exceptions bei Protokollanfragen geführt hätte. Das Problem wurde korrigiert, alte Clients sind nicht betroffen da erweiterte Benachrichtigungen nur an neue Clients gesendet werden.

  - Nerz-Ä–15: Die Interpretation des Zeitstempels des Ende-Archiv-Datensatzes wurde angepasst. Der tatsächliche Zeitstempel des Ende-Archiv-Datensatzes wird ignoriert und für die weitere Verarbeitung durch den Zeitstempel des Intervallendes ersetzt. Dies korrigiert die bisher häufig vorkommenden überflüssigen Datensätze und Lücken gegen Ende eines Intervalls.

  - Nerz-Ä–15: Datenindexsprünge in Änderungsprotokollen (die beispielsweise archivseitig durch weggelassene, identische Daten bei Delta-Anfragen verursacht werden können) werden jetzt nicht mehr fäschlicherweise als Datenlücke erkannt. Dadurch wurde das Auffüllen bei Änderungsprotokollen korrigiert und es werden keine überflüssigen “LEERER DATENSATZ”- Datensätze mehr erzeugt.

  - Nerz-Ä–15: Beim Vergleich von Datensätzen auf Gleichheit werden Zahlwerte nicht mehr nach Double konvertiert. Dies behebt Probleme die beim Vergleich von großen Objekt-IDs aufgetreten sind, da sich Long-Werte nicht verlustfrei auf Doubles abbilden lassen.

  - Die Logik zum Auffüllen von Datensätzen wurde korrigiert. Fehlerdatensätze, Enddatensätze und ähnliches werden nicht mehr zum Auffüllen verwendet.

  - Der PuaClient und der PuA-Server verhalten sich jetzt besser bei der Kommunikation über gekoppelte Datenverteilersysteme, insbesondere warten die Klassen SimpleSender und Sender jetzt eine gewisse Zeit auf positive Sendesteuerung, da die Suche nach Zentraldatenverteilern und Übermittlung der Sendesteuerung an den Zieldatenverteiler u.U. eine kurze Zeit benötigt.

  - In Skripten kam es zu Fehlern, wenn Spaltennamen, Definitionen von temporären Attributen und ähnliches das Schlüsselwort “nicht” enthielten. Die Grammatik-Definition wurde korrigiert.

## Version 2.7.0

- **Änderungen**

  Folgende Änderungen zu vorhergehenden Versionen wurden durchgeführt:

  - Nerz-Ä–12: Begrenzung der Anzahl parallel zu verarbeitenden Archivanfragen seitens einer einzelnen Applikation.

    - Die im Archivsystem eingestellte maximale Anzahl von gleichzeitig für eine Applikation bearbeiteten Archivanfragen wird zur Laufzeit abfragt und entsprechend berücksichtigt.
    - PuA wurde so erweitert , dass eine einzelne PuA-Anfrage nicht mehr zu mehreren gleichzeitig ausgeführten Archivanfragen führt, sondern eine einzelne Archivanfrage mit entsprechend vielen verschiedenen Teilanfragen gestellt wird.

  - Nerz-Ä–16: Performance-Verbesserungen bei der Verwendung von ByteArrays in den Datenverteiler-Applikationsfunktionen. Verwendung der neuen Methoden des Data-Interface zum Setzen von byte[, short[], int[] etc.

  - Nerz-Ä–6: Bei versionierten Konfigurationsänderungen werden für die betroffenen Objekte neue Konfigurationsobjekte mit neuer ID und gleicher Pid in der Konfiguration erzeugt. Um eine Archivanfrage für ein so geändertes Objekt über den Versionswechsel hinaus durchzuführen, musste die anfragende Applikation bisher die verschiedenen Konfigurationsobjekte mit der gewünschten Pid im Anfragezeitbereich ermitteln und alle gefundenen Objekte in der Archivanfrage angeben.
    - Die vom PuA-Server durchgeführten Archivanfragen wurden so angepasst, dass das neue API für Archivanfragen verwendet wird, bei dem die Pids der gewünschten Objekte angegeben werden.

- **Bugfixes**

  Folgende Probleme vorhergehender Versionen wurden behoben:

  - Nerz-F–83: Wenn das Archiv auf eine Protokollanfrage von PuA nicht antwortet kann es passieren, dass das Abbrechen einer Protokollanfrage nicht dazu führt, dass die Archivanfrage abgebrochen wird. Zur Lösung des Problems wurde der Code in PuA so angepasst, dass bei Abbruch einer Auswertung der auf Archivantworten wartende Thread in PuA unterbrochen wird und die Archivanfrage abgebrochen wird.

## Version 2.6.0

- **Abhängigkeiten zu Datenmodellen**

  siehe Version 2.4

- **Abhängigkeiten zu Bibliotheken**

  siehe Version 2.4

- **Softwareänderungen**

  Folgende Erweiterungen, Änderungen und Korrekturen gegenüber vorhergehenden Versionen wurden durchgeführt:

   - Es wurde ein Problem korrigiert, das beim anfrageseitigen Zugriff auf eine Attributliste in einem PuA-Ergebnisdatensatz mit der Methode Data.isDefined() in bestimmten Fällen zu einer NullPointerException führen konnte.
   - Es wurde ein Problem korrigiert, das bei Verwendung von undefinierten Elementen in einer Pseudoobjektdefinition zu NullPointerExceptions beim Zugriff auf das Archiv führen konnte.

## Version 2.5.0

- **Abhängigkeiten zu Datenmodellen**

  siehe Version 2.4

- **Abhängigkeiten zu Bibliotheken**

  siehe Version 2.4

- **Softwareänderungen**

  Folgende Erweiterungen, Änderungen und Korrekturen gegenüber vorhergehenden Versionen wurden durchgeführt:

   - PuA stellt für eine Datenidentifikation nicht mehr je Attribut beim Archiv eine Anfrage, sondern nur noch einmal. Dadurch kann die Anzahl Streams der resultierenden Archivanfrage je nach PuA-Skript erheblich reduziert werden und die Verarbeitungsgeschwindigkeit entsprechend gesteigert werden.

## Version 2.4.0

- **Abhängigkeiten zu Datenmodellen**

  Es werden aktualisierte Versionen der Datenmodelle des kv.kappich und des kv.bea benötigt:

   - kv.kappich:

     Der Bereich kb.systemModellGlobal wird in Version 25 benötigt.

   - kv.bea:

     Der Bereich kb.tmVewProtokolleGlobal wird in Version 4 benötigt.

- **Abhängigkeiten zu Bibliotheken**

   - Die Bibliothek de.bsvrz.sys.funclib.losb wird in aktueller Version benötigt. Diese ist im Release enthalten.
   - Die Bibliothek antlr wird in Version 2.7.7 benötigt. Diese ist im Distributionspaket im lib-Verzeichnis enthalten.
   - Die Bibliothek de.bsvrz.sys.funclib.dynobj wird in Version 1.0.2 benötigt.

- **Softwareänderungen**

  Folgende Erweiterungen, Änderungen und Korrekturen gegenüber vorhergehenden Versionen wurden durchgeführt:

   - Die Distributionspakete de.bsvrz.pua.prot und de.bsvrz.sys.funclib.losb können jetzt auch als Eclipse-Plugins bzw. OSGi-Bundles verwendet werden. Dazu wurde in den Hauptverzeichnissen der Distributionspakete eine META-INF/MANIFEST.MF-Datei mit den jeweils notwendigen Inhalten ergänzt. Die Distributionspakete werden mit gleichem Inhalt auch als OSGi-Bundles in eigenen JAR-Dateien zur Verfügung gestellt.
   - Bei der Benachrichtigung eines von der Applikation bereitgestellten Listeners bzgl. der Fertigstellung eines Protokolls konnte es zu Blockierungen mit entsprechenden Timeouts kommen, wenn in der Benachrichtigungsmethode eine weitere Anfrage an PuA gestellt wurde. Die Benachrichtigung wird jetzt durch einen separaten entkoppelten Thread durchgeführt.
   - Bei Nutzung des Kommandozeilen-PuA-Client `CmdPua` konnte es unter bestimmten Umständen zu einer `NullpointerException` kommen, wenn der benötigte Aufrufparameter `datenarten` nicht angegeben wurde. Das Vorhandensein des Aufrufparameters wird jetzt überprüft und gegebenenfalls eine entsprechende Fehlermeldung ausgegeben.
   - In PuA konnte es server-seitig bei bestimmten Anfragen zu einer `NullpointerException` beim Versand von Antworten kommen. Ursache war der fehlerhafte Versuch von PuA nicht vorhandene Objekte an den Client weiterzuleiten. Dies wurde behoben.
   - Wenn beim Aufruf der Methode PuaClient.getUnreadProtocolList() der zweite Parameter `null` war, dann konnten keine Protokolle mehr von PuA abgerufen werden. Das Problem wurde behoben.
   - Beim Zugriff auf die Ergebnisswerte einer bestimmten Aggregation mit Hilfe der Methode `ProtocolAggregationResultData.getData(DataModel, int, String`), wurde eine `IllegalArgumentException` geworfen, wenn zu der angegebenen Aggregation keine Daten enthalten waren. In der neuen Version wird in diesem Fall `null` zurückgegeben.
    - Es wurde eine neue Methode `ProtocolAggregationResultData.getAggregations(int)` ergänzt, mit der die definierten Aggregationen für den angegebenen Spaltenindex abgefragt werden können.
   - PuA wurde so erweitert, dass die `PuaClient.getDefaults()`-Methode zusätzlich alle Aspekte zurückgibt, die gebunden werden können. Dazu gibt es die neue Methode `List <String> getAspects()` in der Klasse `AtlDefaults`.
   - PuA wurde so erweitert, dass die PuaClient.getDefaults()-Methode zusätzlich alle Aliase mit zugehörigem Objekttyp liefert. Dazu gibt es die neue Methode `Map <String, SystemObjectType> getAliases()` in der Klasse` AtlDefaults`.
   - Bei der Verarbeitung eines Skripts kam es zu einer `NullPointerException`, wenn im Skript nicht explizit eine Protokollart im Standards-Bereich vorgegeben war. Dieses Problem wurde behoben. Keine explizite Angabe im Skript wird jetzt implizit als `protokollart zustandsprotokoll` interpretiert.
   - Die `PrettyPrinter`-Funktionalität zur automatischen Formatierung von Skripten hat überflüssige Zeilenumbrüche nach dem Schlüsselwort `protokollart` eingefügt. Diese Inkonsistenz wurde korrigiert.
   - Die `PrettyPrinter`-Funktionalität hat eine fehlerhafte Ausgabe bei ungebundenen Aliasen generiert, wenn diese innerhalb eines Mit-Blocks benutzt wurden. Der Fehler wurde korrigiert.

## Version 2.3.0

- **Abhängigkeiten zu Datenmodellen**

  Es werden aktualisierte Versionen der Datenmodelle des kv.kappich und des kv.bea benötigt:

   - kv.kappich:

     Der Bereich kb.systemModellGlobal wird in Version 25 benötigt.

   - kv.bea:

     Der Bereich kb.tmVewProtokolleGlobal wird in Version 3 benötigt.

- **Abhängigkeiten zu Bibliotheken**

   - Die Bibliothek de.bsvrz.sys.funclib.losb wird in aktueller Version benötigt. Diese ist im Release enthalten.
   - Die Bibliothek antlr wird in Version 2.7.7 benötigt. Diese ist im Distributionspaket im lib-Verzeichnis enthalten.
   - Die Bibliothek de.bsvrz.sys.funclib.dynobj wird in Version 1.0.2 benötigt.

- **Softwareänderungen**

  Folgende Erweiterungen, Änderungen und Korrekturen gegenüber vorhergehenden Versionen wurden durchgeführt:

   - Abhängigkeit zu einer noch nicht veröffentlichten neuen Version der Datenverteiler-Applikationsfunktionen wurde wieder eliminiert. Mindestvorraussetzung ist Release 3.4.10 der Kernsoftware.

## Version 2.2.0

- **Abhängigkeiten zu Datenmodellen**

  Es werden aktualisierte Versionen der Datenmodelle des kv.kappich und des kv.bea benötigt:

  - kv.kappich:

    Der Bereich kb.systemModellGlobal wird in Version 25 benötigt.

  - kv.bea:

    Der Bereich kb.tmVewProtokolleGlobal wird in Version 3 benötigt.

- **Abhängigkeiten zu Bibliotheken**

  - Die Bibliothek de.bsvrz.sys.funclib.losb wird in aktueller Version benötigt. Diese ist im Release enthalten.
  - Die Bibliothek antlr wird in Version 2.7.7 benötigt. Diese ist im Distributionspaket im lib-Verzeichnis enthalten.
  - Die Bibliothek de.bsvrz.sys.funclib.dynobj wird in Version 1.0.2 benötigt.

- **Softwareänderungen**

  Folgende Erweiterungen, Änderungen und Korrekturen gegenüber vorhergehenden Versionen wurden durchgeführt:

  - Die Jar-Datei *de.bsvrz.pua.prot-runtime.jar* enthält neben der Classpath Erweiterung auf alle benötigten Distributionspakete und Bibliotheken auch den Namen der Main-Klasse. Damit gibt es die Möglichkeit PuA mit `java ... -jar de.bsvrz.pua.prot-runtime.jar ...` ohne Angabe eines Classpath und ohne Angabe der Mainklasse zu starten.

  - Attributlisten und Arrays können jetzt bei der Aggregation benutzt werden

  - Einschränkungen(Filter) können jetzt auch mit Alias verwendet werden. Beispiel:

    ```
  	spalten:
  		attribut fs:atg.verkehrsDatenKurzZeitFs:asp.agregation1Minute:qKfz
  	filter:
  		einschränkung fs:atg.verkehrsDatenKurzZeitFs:asp.agregation1Minute:qKfz.Güte.Index <> "nicht ermittelbar"
  	definitionen:
  		alias fs = typ.fahrStreifen
    ```

    Der Filterausdruck bezieht sich nur auf das aktuelle PseudoObjekt-Tupel, dessen Werte bei Ausfilterung dann gegebenenfalls leer bleiben.

  - Es können jetzt auch beliebig tief geschachtelte Attribute genutzt werden. Beispiele: `typ.fahrStreifen:atg.verkehrsDatenKurzZeitFs:asp.agregation1Minute:qKfz.Güte.Index` oder `objekt:atg:asp:att1[5].att2.att3.att4[0].refattr:atg2:asp2:att[1]` usw. Zu beachten ist, dass die Attribute untereinander wie bisher mit einem Punkt getrennt werden, nicht mit einem Doppelpunkt. Eine verschachtelte Attributspezifikation mit Zugriff über mehrere Attributlisten und Arrays wie z.B. `feld[25].x.y[3].z` ist damit jetzt möglich.

   - Indizes beim Zugriff auf Datenarrays waren überwiegend 1-basiert, sind jetzt generell 0-basiert. Der zugehörige Code war fehlerhaft (Zugriff auf Index 0 wurde z.B. dennoch zugelassen) und wurde korrigiert.

  - PuA unterstützt das Terminate-Signal und beendet sich kontrolliert bei Empfang des Signals

  - PuA beendet sich kontrolliert, wenn die Verbindung zum Datenverteiler unterbrochen wurde.

  - Clientseitig können jetzt mehrere PuA-Anfragen parallel gestellt und abgerufen werden.

  - Wenn client-seitig in einer Applikation mehrere parallele PuA-Anfragen durchgeführt wurden, dann führte dies zu mehrfachen Anmeldungen beim Datenverteiler als Senke für PuA-Antworten, was von den Datenverteiler-Applikationsfunktionen mit entsprechenden Fehlermeldungen quittiert wurde.

  - Die von `PuaClient.getRequestId()` vergebenen IDs waren bei Verwendung von mehreren PuaClient-Objekten nicht zwangsweise eindeutig. `PuaClient.getRequestId()` liefert jetzt auch bei mehreren PuaClient-Instanzen eindeutige Anfrage-Ids. Diese werden fortlaufend beginnend bei 1 vergeben.

  - Mit Hilfe der Methode `PuaClient.getIsActive(`) kann clientseitig abgefragt werden, ob PuA und das von PuA verwendete Archivsystem läuft. Die Methode liefert true zurück wenn PuA läuft und das Archivsystem erreichen kann.

  - Die Ergebnisdaten können wie gehabt abgerufen werden. Die Klassen `ProtocolResultData` und `ProtocolAggregationResultData` (siehe weiter unten). bieten jetzt u.A. die Methode `getData()` mit dem ein Data-Objekt erzeugt werden kann, dass automatisch die Skalierung von Werten und den Zugriff auf Einheiten und Zustandswerte übernimmt. Der Zugriff auf die alte values-Eigenschaft ist nicht mehr zu empfehlen, da dort durch weitere Änderungen jetzt andere, neuartige und teilweise auch unerwartete Wertetypen und insbesondere auch skalierte Werte enthalten sind. Falls dennoch ein direkter Zugriff stattfinden soll, sollte grundsätzlich beachtet werden, dass `long`-Werte generell unskaliert und `double`-Werte generell skaliert sind. Für die Prüfung, ob ein Datensatz vorhanden ist, kann die Funktion `isDefined()` im Data-Objekt benutzt werden.

  - Ausgaben von Werten mit Skalierungsfaktor werden grundsätzlich in skalierter Form durchgeführt. Die skalierten Werte und die Einheit lassen sich über das oben erwähne Data-Objekt abrufen (`getScaledValue, getSuffixText, getAttributeType` usw.)

  - Werte mit Skalierungsfaktor werden jetzt PuA-seitig grundsätzlich skaliert verarbeitet, z.B. in Tempattribut-Ausdrücken, Filtern oder Aggregationen. Zeitwerte werden generell als Millisekunden behandelt. Zustandswerte außerhalb des Wertebereichs werden nicht aggregiert, können nicht in mathematischen Operationen benutzt werden, und können ähnlich einem String benutzt werden (z.B. Textvergleiche, Konkatenationen). Zustandswerte innerhalb des Wertebereichs werden aggregiert, und können natürlich in Berechnungen benutzt werden, können aber ebenso mit Strings verglichen werden. Da PuA mit skalierten Werten rechnet, ist es möglich, dass z.B. bei Benutzung der Summe-Aggregation der Wertebereich des Attributtyps überschritten wird. Da der skalierte Wert übertragen wird und dieser vom oben erwähnten Data-Objekt entsprechend verarbeitet wird, führt dies normalerweise zum erwünschten Ergebnis, nämlich, dass die Zahl einfach beim Client ankommt und abrufbar ist. Falls festzustellen ist, ob die Zahl innerhalb des Wertebereichs ist, kann `isNumber()` aufgerufen werden. Da die Zahlen als double verarbeitet werden, können aufgrund der begrenzten Genauigkeit geringfügige Rechenfehler entstehen.

  - Bei Auswertungen mit einem Zeitbereich in der Zukunft fasst PuA jetzt Onlinedaten mit gleichem Datenzeitstempel zusammen, sofern diese hintereinander eintreffen.

  - Wenn die maximale Anzahl parallel laufender Auswertungen erreicht ist, dann werden weitere Anfrage in eine Warteschlange gestellt. Der Timeout in PuaClient wurde entfernt. Damit wartet der Client jetzt solange, bis PuA bereit ist, den Auftrag anzunehmen, anstatt eine Fehlermeldung zu werfen. Die Warteschlange kann PuA-seitig mit dem Aufrufargument `-groesseWarteschlange=x` angepasst werden. Bei dem Wert 0 erhalten Clients sofort eine Fehlermeldung, wenn alle Threads belegt sind.

  - Die in PuA enthaltene Grammatik wurde mit dem Parser Generator antlr in Version 2.7.7 übersetzt. Diese neuere Version ist incl. Quellcode im lib-Verzeichnis des Distributionspakets enthalten. Evtl. im ClassPath angegebene ältere Versionen sollten entfernt werden.

  - Standardwerte können mit der Methode `PuaClient.getDefaults()` abgefragt werden, diese Funktion verhält sich ähnlich zu `getSource()`. Beispielaufruf:

    ```
	final AtlDefaults atlDefaults = new AtlDefaults();
	final AtlMeta atlMeta = new AtlMeta();
	final ProtocolRequestResult requestResult = puaClient.getDefaults(script, atlDefaults, atlMeta);
    ```
    Anschließend befinden sich die Standardwerte in `atlDefaults`.

  - Informationen über Ersteller und Erstellungsdatum können jetzt beim Protokoll-Erstellen angegeben werden und stehen beim Abruf des Protokolls im `ProtocolAdministrationData` als `creatorName` und `protocolDate` zur Verfügung.

  - Der beim Erstellen eines Protokolls gelieferte Stream kann mit der Methode `abort()` definiert geschlossen werden können. Nach dem Aufruf von abort() wird jetzt in jedem Fall eine definierte Fehlermeldung ausgegeben. ("Verbindung zum Server wurde geschlossen.")

  - Mit Hilfe der Methoden `PuaClient.addProtocolListener()` und `PuaClient.removeProtocolListener()` kann sich ein Client über die Fertigstellung eines im Hintergrund erstellten und gesicherten Protokolls benachrichtigen lassen. Es wird für jedes fertig gestellte Protokoll die Protokoll-ID übertragen und an den von der Anwendung implementierten Listener übergeben.

  - Bei der Protokollerstellung lassen sich auch mit `ProcessingParameter.setInfoText()` und `ProcessingParameter.setIsPublic()` Beschreibungstext und Benutzer-Flag festlegen. Bei Protokollauflistungen vom PuaClient werden nur öffentliche Protokolle und Protokolle des übergebenen Benutzers geliefert. Der Beschreibungstext ist im `ProtocolAdministrationData.infoText` abrufbar.

  - Das oben erwähnte Data-Objekt enthält einen Ergebnisdatensatz von PuA in strukturierter Form und kann über die üblichen Data-Funktionen ausgelesen werden. Eine eindimensionale Darstellung der Attributliste bzw. -gruppe, die sich z.B. für die Darstellung in Spalten eignet ist über `ProtocolData.convertDataToList(...)` generierbar.

  - Die Liste der Aggregationsarten (Anwendungen) sind jetzt über die Methode `ProtocolAggregationData.getOrders()` des Aggregationsdatensatzes abrufbar.

  - In jedem Protokoll wird als zweiter Datensatz der Aggregationsdatensatz geliefert, der die verwendeten Aggregationen und Anwendungen beinhaltet auch wenn keine explizite Aggregation definiert wurde.

  - Für ein Attribut können jetzt mehrere Aggregationen über ein Komma getrennt angegeben werden. Beispiel:

    ```
	fs:atg.verkehrsDatenKurzZeitFs:asp.agregation1Minute:qKfz.Güte.Index: aggregation mittelwert, summe, maximum
    ```

    Da die Aggregations-(Ergebnis-)Datensätze dadurch mehr als ein Datum pro Spalte erhalten und auch weitere Informationen enthalten, werden Aggregationsergebnisse jetzt in der Klasse `ProtocolAggregationResultData` übertragen. Diese bietet, analog zu den oben erwähnten Data-basierten Methoden, Methoden um z.B. das Ergebnis einer speziellen Aggregation abzurufen.

  - Beim Erstellen eines Skriptes wird jetzt auf kompatible Typen geprüft. Zur Vereinfachung und besseren Kompatibilität sind alle Werte in String-Typen (z.B. att.text) konvertierbar [1]. Die Liste der möglichen Konvertierungen ist wie folgt:

    ```
    string
        StringAttributeType
    boolean
        att.jaNein, StringAttributeType
    zahlwerte
        StringAttributeType, DoubleAttributeType, TimeAttributeType [2] sowie IntegerAttributType mit Wertebereich.
    ```

    [1] Die PuA-seitige Konvertierung in Strings findet derzeit ohne nennenswerte Berücksichtigung des Attributtypen statt. So befinden sich im String-Wert weder Einheiten, noch attributtyp-spezifische Formatierungen. Ein Zeitattribut mit dem Wert "1 Minute" wird also z.B. für Stringvergleiche, Konkatenationen usw. einfach als "60.000" behandelt. Clientseitig berücksichtigt das in AP 6 implementierte Data-Objekt den Attributtypen und liefert, falls dieser sinnvoll gewählt ist, eine bessere Ausgabe.

    [2] Zeitattribut-Werte werden generell als Millisekunden behandelt. Sowohl beim Konvertieren von einem Datenwert in einen Zahlwert zur internen Verarbeitung in Berechnungen, Vergleichen usw., als auch beim Rückkonvertieren in ein Zeitattribut.

  - Mehrere Pseudoobjekt-Spezifikationen sind im standards-Bereich nicht mehr möglich.

  - Skripte können jetzt nur entweder eine Pseudoobjekt-Definition verwenden, einen einzigen Objekttypen angeben (und diesen durch das Hauptobjekt (oder ein evtl. definiertes Standard-Objekt) auflösen) oder direkt ein einziges Objekt im Skript verwenden. Dadurch ist die Angabe von zusätzlichen Objekten über den bisherigen Parameter nicht mehr sinnvoll. Diese Funktionalität wurde entfernt. Die Angabe von mehreren Standardobjekten, insbesondere zu einem einzelnen Typ, ist ebenso nicht mehr möglich.

  - Aliase können jetzt auch in TempAttributen verwendet werden. Beispiel:

    ```
	spalten:
		attribut fs:atg.verkehrsDatenKurzZeitFs:asp.agregation1Minute:qKfz
		tempAttribut test
	filter:
	definitionen:
		tempAttribut test:att.jaNein=fs:atg.verkehrsDatenKurzZeitFs:asp.agregation1Minute:qKfz.Güte.Index > 0.5
		alias fs = typ.fahrStreifen
    ```

    Dabei werden, wie von realen Attributen gewohnt, mehrere Spalten pro Attributangabe erzeugt.

  - Client-seitig ist in den Ergebnissen die Trennung und Zuordnung der Ergebnisse entsprechend den in der Anfrage angegebenen Zeitintervalle erkennbar. Ergebnisdatensätze haben jetzt die Funktion `getIntervalIndex()` mit der der verwendete Zeitintervallindex ausgegeben werden kann. Da die Zeitintervalle PuA-seitig sortiert verarbeitet werden, ist es möglicherweise zur besseren Zuordnung sinnvoll, bereits zeitlich sortierte Eingabezeitintervalle zu verwenden.

  - Bei Aggregationsergebnisdatensätzen kann auf Anfangs- und Endzeitstempel des aggregierten Intervalls zugegriffen werden. Dazu bietet ein Aggregationsergebnisdatensatz jetzt die Funktionen `ProtocolAggregationResultData.getStartTimeStamp()` sowie `ProtocolAggregationResultData.getEndTimeStamp()` sowie die Fields `ProtocolAggregationResultData.startTimeStamps` und `ProtocolAggregationResultData.endTimeStamp`s, die sich wie die Zeitstempel von normalen Ergebnisdatensätzen verhalten.

  - Die Prüfung, ob ein Wert ein Zustand ist, und damit nicht aggregiert werden sollte, hat nicht funktioniert und wurde korrigiert. Zustandswerte, die nicht in einem Wertebereich liegen, werden jetzt generell nicht aggregiert.

  - In `PuaClient.getStatus()` konnte eine `NullPointerException` auftreten, z.B. wenn ein Client eine PuA-Anfrage gestellt hat und PuA zu diesem Zeitpunkt nicht lief.

  - Die Mittelwertaggregation von Boolean-Werten ergab wenig sinnvolle Ergebnisse (`[false, false, true, false] => true`, oder sogar `[false, false, false, false] => true`). Das Problem wurde so korrigiert, dass das Ergebnis `true` ist, wenn mindestens die Hälfte der Booleans `true` sind.

  - Fehlerkorrektur in `BaseDataSet.compareData()`, die Prüfung auf Null-Werte wurde nur für das erste Array durchgeführt und zwar doppelt. Der entsprechende Zugriff wurde korrigiert.

  - Prüfung auf ungültige Simulationsvariante als Parameter beim Protokollerstellen hat im Konstruktor von `ProcessingParameter()` nicht funktioniert und wurde korrigiert.

  - Die Methode `isArithmetic()` hat für Zustandswerte, die nicht in einem Wertebereich liegen, falsche Ergebnisse geliefert und wurde korrigiert.

  - In den Klassen `ProtocolRequestReceiver` waren fehlerhafte Thread-Synchronisationen enthalten, die in seltenen Fällen zur Blockierung von PuA führen konnten.

  - Beim Speichern eines Skripts wurde die Versionsnummer in `atl.Detail` nicht aktualisiert. Das Problem wurde korrigiert.

  - Die Aufrufparameter `-kommandoPort=...` und `-kommandoTimeout=...` für den in PuA enthaltenen Telnet-Server wurden nicht korrekt ausgewertet. Problem wurde analysiert und behoben.

  - Pseudoobjekte können jetzt 'unvollständig' definiert werden, indem ein Leerstring oder null-Objekt als Platzhalter verwendet wird. Diese Platzhalter generieren leere Platzhalterspalten ohne Daten. Beispiel:

    ```
	(fs,mq,mqü)=(fs1,mq1,)(fs2,,mq2ü)(fs3,,)(,mq3,mq3ü)
	```

    Diese Syntax ist für den Standardwert innerhalb des Skriptes oder für `CmdPua` zu verwenden. Wenn `ProcessingParameter` benutzt wird, kann das entsprechende Array mit `null`-Werten oder Leerstrings ($quot;$quot;) befüllt werden. Siehe `ProcessingParameter.setPseudoObjects()`. Die Angabe von anderen nicht existierenden Objekten führt jetzt zu einem definierten Fehler und nicht wie bisher zu einem Crash durch eine `NullPointerException`.

  - Das Interface der Klasse `ProcessingParameter` wurde angepasst, indem öffentliche Fields durch Getter und Setter ersetzt wurden, damit auf zuverlässige Weise eine Gültigkeitsprüfung durchgeführt werden kann. Desweiteren wurden Änderungen an den enthaltenen Werten vorgenommen, die entweder notwendig waren oder für sinnvoll gehalten wurden:
     - Das Hauptobjekt ist jetzt optional.
     - Der Objekte-Parameter existiert nicht mehr. (siehe oben)
     - Datenarten können jetzt auch über eine `ArchiveDataKindCombination`gesetzt und auslesen werden.
     - Pseudoobjekte können unvollständig definiert werden.
     - Pseudoobjekte können jetzt auch als `Map<String, List<String>>` übergeben werden. Der bisherige Weg über eine `Hashtable<String, String[]>` (bzw. jetzt eine `Map<String , String[]>`, siehe nächster Punkt) wird aus Kompatibilitätsgründen noch unterstützt.
     - ProcessingParameter akzeptiert neben den bisherigen Typen `Hashtable`, `HashSet` und `List` jetzt allgemeinere Klassen vom Typ `Map`, `Set` und `Collection`.
     - Die Klasse speichert jetzt Kopien der übergebenen Objekte um sicherzustellen, dass die privaten Fields von außen nur über die Getter und Setter änderbar sind.
     - Zugriff auf weitere oben genannte Eigenschaften wie Ersteller, Erstellungsdatum, Freitext und eine Kennung, ob das Protokoll nur vom Ersteller oder allgemein verwendbar ist.
     - Änderung der Konstruktoren.

  - Neben der bereits vorhandenen Objekt-ID lässt sich zur leichteren Zuordnung jetzt pro Spalte auch der verwendete Alias und Pseudo-Objekt-Index auslesen. Der Alias ist nicht bei TempAttribut-Spalten enthalten, da mehrere Aliase in einer Berechnung enthalten sein können und so eine einfache, klare Zuordnung nicht möglich ist. Diese Information lässt sich über `ProtocolAdministrationData.columns[x]` abrufen, wobei die von Column geerbten Klassen `RealAttributeColumn` und `TempAttributeColumn` entsprechende Methoden (`getAlias(), getPseudoObjektIndex()`) beinhalten.

  - Da für Aggregationsergebnisdatensätze eine neue Klasse verwendet wurde, ist die Eigenschaft `ProtocolResultData.order` nicht mehr sinnvoll, da diese immer LISTE enthält. Die Eigenschaft ist aus Kompatibilitätsgründen noch vorhanden, sollte aber nicht mehr benutzt werden.

  - Angabe `zustandsprotokoll` bewirkte im Skript das falsche Verhalten. Es wurde dann ein Änderungsprotokoll erstellt. Das Problem wurde korrigiert.

  - Es konnte vorkommen dass in einem Protokoll Datensätze fehlten. Die Ursache des Problems war ein Fehler in den Aggregationsfunktionen und wurde behoben.

  - Die in den Klassen `ArchiveBuffer, OnlineDataReceiverObject, Processing, ProtocolRequestReceiver, ThreadElement` enthaltenen Thread-Synchronisierungen waren fehlerhaft und wurden korrigiert.


[Noch nicht veröffentlicht]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.pua.prot/compare/v2.10.1...HEAD
[Version 2.10.1]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.pua.prot/compare/v2.10.0...v2.10.1
