/*
 * Copyright 2005-2008 by beck et al. projects GmbH, Munich
 * Copyright 2009 by Kappich Systemberatung, Aachen
 * 
 * This file is part of de.bsvrz.pua.prot.
 * 
 * de.bsvrz.pua.prot is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * de.bsvrz.pua.prot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with de.bsvrz.pua.prot.  If not, see <http://www.gnu.org/licenses/>.
 */

package de.bsvrz.pua.prot.filters;

import de.bsvrz.pua.prot.processing.util.IntermediateDataSet;

/**
 * Schnittstelle für Nachfilter.
 *
 * @author beck et al. projects GmbH
 * @author Martin Hilgers
 */
public interface PostFilter {

	/**
	 * Wird für jeden Ausgangsdatensatz aufgerufen.
	 *
	 * @param baseData Ausgangsdatensatz.
	 *
	 * @return Ergebnisdaten des Nachfilters.
	 */
	public IntermediateDataSet processDataRecord(IntermediateDataSet baseData);

	/**
	 * Wird für jeden aggregierten Ausgangsdatensatz aufgerufen.
	 *
	 * @param baseData Aggregierter Ausgangsdatensatz.
	 *
	 * @return Ergebnisdaten des Nachfilters.
	 */
	public IntermediateDataSet processAggregationRecord(IntermediateDataSet baseData);
}
